/*
GEST : GESTure Tracking
Copyright (C) 2006-2010  Brice Burger (LAAS-CNRS)
Ce code est protéger par une license APP
*/

#ifndef MESUREDISTANCE_H
#define MESUREDISTANCE_H

/* 
 * 
 * Ce fichier contient les fonctions nécessaires au calcul d'une image de distance (i.e. distance par rapport aux contours) et des opérations sur cette image.
 * 
 * \author BURGER Brice
 * \since 04/2007
 */

#include <cv.h>
#include <highgui.h>
#include "detectionParams.h"




class MesureDistance {

	IplImage* imgNG;//image en cours en niveau de gris
	IplImage* imgtemp;//image temporaire pour le calcul de l'image de distance qui doit être en 32F
	
	CvRect rect;//rectangle utilisé pour les ROIs

public:

	IplImage* dist;//image de distance


	/** Constructeur */
	MesureDistance();

	/** Destructeur */
	~MesureDistance();
	
	/** Remise À Zéro d'une image
	 * 
	 * cette fonction est nécessaire quand on travail sur des images avec ROI :
	 * on ne calcule alors que sur certaines parties de l'image, le reste de l'image ne correspondant donc à rien
	 * (c'est donc essentiellement pour l'affichage qu'il faut faire une RAZ)
	 */
	void RAZ();
	
	/** calcule l'image de mouvement
	 *
	 * \param img : image courante (RGB ou NG)
	 */
	void calculeImgDist(IplImage* img);

};
#endif
