/*
GEST : GESTure Tracking
Copyright (C) 2006-2010  Brice Burger (LAAS-CNRS)
Ce code est protéger par une license APP
*/

#ifndef MESUREMVT_H
#define MESUREMVT_H

/* 
 * 
 * Ce fichier contient les fonctions nécessaires au calcul d'une image de mouvement et des opérations sur cette image.
 * 
 * \author BURGER Brice
 * \since 03/2007
 */

#include <cv.h>
#include <highgui.h>
#include "detectionParams.h"




class MesureMvt {

	IplImage* imgprec;//image précédente (traduite en niveau de gris)
	IplImage* imgcour;//image courante (traduite en niveau de gris)
	IplImage* imgtemp;//pour l'échange de pointeurs
	
	CvRect rect, rectgrand;//rectangles utilisés pour les ROI lors de la conversion

public:

	IplImage* mvt;//image de mouvements


	/** Constructeur */
	MesureMvt();

	/** Destructeur */
	~MesureMvt();
	
	/** Remise À Zéro d'une image
	 * 
	 * cette fonction est nécessaire quand on travail sur des images avec ROI :
	 * on ne calcule alors que sur certaines parties de l'image, le reste de l'image ne correspondant donc à rien
	 * (c'est donc essentiellement pour l'affichage qu'il faut faire une RAZ)
	 */
	void RAZ();
	
	/** calcule l'image de mouvement
	 *
	 * \param nouveau : si true, il s'agit d'une nouvelle image, sinon on calcule sur la même image mais dans une ROI différente
	 */
	void calculeImgMvt(IplImage* img, bool nouveau);

};
#endif
