/*
GEST : GESTure Tracking
Copyright (C) 2006-2010  Brice Burger (LAAS-CNRS)
Ce code est protéger par une license APP
*/

#ifndef MESUREMVT3D_H
#define MESUREMVT3D_H

/**
 * 
 * Ce fichier contient les fonction nécessaires au calcul des images de mouvements à partir de coordonnées 3D.
 * 
 * \author BURGER Brice
 * \since 03/2007
 */

#include <cv.h>
#include <highgui.h>
#include "detectionParams.h"
#include "mesureMvt.h"
#include "projection.h"



class MesureMvt3D {

	MesureMvt *mesureMvtG;
	MesureMvt *mesureMvtD;
	
	/* pour la projection */
	int rayon;
	CvPoint point2dgauche, point2ddroite;
	
	public:

	/** Constructeur */
	MesureMvt3D();

	/** Destructeur */
	~MesureMvt3D();
	
	/** obtention de l'image de mouvement Gauche
	 * 
	 */
	IplImage* getImgMvtG();

	/** obtention de l'image de mouvement Droite
	 * 
	 */
	IplImage* getImgMvtD();
	
	/** calcule les images de mouvement gauche et droite dans la zone indiquée
	 *
	 * \param nouveau : si true, il s'agit d'une nouvelle image, sinon on calcule sur la même image mais dans une ROI différente
	 * \param imgG,imgD : images à traiter
	 * \param zones : zones 3D de recherche du visage (sous forme des rectangles projetés sur les images) (NULL pour calculer sur toute l'image)
	 */
	void calculeImgMvt(bool nouveau, IplImage* imgG, IplImage* imgD, CvRect* zones);

};
#endif
