/* Copyright (c) Ludovic Brethes (LAAS-CNRS) */
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VIDEOIMGSEQ_H
#define VIDEOIMGSEQ_H

#include <cv.h>
#include <highgui.h>
#include <stdio.h>
#include <iostream>
#include <string>
using std::string;


class videoimgseq
{
private:
  string rep;
  string fileprefix;
  string ext;
  int deb,fin;
  int nbdigits;
  int curimg;
  char fileproto[256];
  char filename[256];


public:
  videoimgseq(string rep, string fileprefix, string ext, int deb, int fin, int nbdigits=5);
  ~videoimgseq();

  bool init();
  bool grab();
  
    /** image width  */
  int width;

  /** image height */
  int height;

  /** image number */
  int number;

  /** image  */
  IplImage * image;

  /** read current image */
  inline IplImage * get() { return this->image; };

  /** grab new image and return it */
  inline IplImage * next() 
  { 
    if(grab()) return this->image;
    return 0;
  };

  /** return image width */
  inline int w() { return this->width; };

  /** return image height */
  inline int h() { return this->height; };

  /** return image number */
  inline int nb() { return this->number; };  
  
};

#endif
